package com.fjhx.customer.service.customer.impl;

import com.baomidou.dynamic.datasource.annotation.DS;
import com.baomidou.dynamic.datasource.annotation.DSTransactional;
import com.fjhx.customer.entity.customer.po.CustomerFollowRecords;
import com.fjhx.customer.mapper.customer.CustomerFollowRecordsMapper;
import com.fjhx.customer.service.customer.CustomerFollowRecordsService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.fjhx.file.utils.ObsFileUtil;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.customer.entity.customer.vo.CustomerFollowRecordsVo;
import com.fjhx.customer.entity.customer.dto.CustomerFollowRecordsSelectDto;
import com.ruoyi.common.utils.wrapper.IWrapper;
import com.fjhx.customer.entity.customer.dto.CustomerFollowRecordsDto;
import cn.hutool.core.bean.BeanUtil;
import oshi.util.FileUtil;


/**
 * <p>
 * 客户跟进记录 服务实现类
 * </p>
 *
 * @author 
 * @since 2023-05-05
 */
@Service
public class CustomerFollowRecordsServiceImpl extends ServiceImpl<CustomerFollowRecordsMapper, CustomerFollowRecords> implements CustomerFollowRecordsService {

    @Override
    public Page<CustomerFollowRecordsVo> getPage(CustomerFollowRecordsSelectDto dto) {
        IWrapper<CustomerFollowRecords> wrapper = getWrapper();
        wrapper.orderByDesc("cfr", CustomerFollowRecords::getId);
        Page<CustomerFollowRecordsVo> page = this.baseMapper.getPage(dto.getPage(), wrapper);
        return page;
    }

    @Override
    public CustomerFollowRecordsVo detail(Long id) {
        CustomerFollowRecords CustomerFollowRecords = this.getById(id);
        CustomerFollowRecordsVo result = BeanUtil.toBean(CustomerFollowRecords, CustomerFollowRecordsVo.class);
        return result;
    }

    @DSTransactional
    @Override
    public void add(CustomerFollowRecordsDto customerFollowRecordsDto) {
        this.save(customerFollowRecordsDto);
        ObsFileUtil.saveFile(customerFollowRecordsDto.getFileList(),customerFollowRecordsDto.getId());
    }

    @DSTransactional
    @Override
    public void edit(CustomerFollowRecordsDto customerFollowRecordsDto) {
        this.updateById(customerFollowRecordsDto);
        ObsFileUtil.editFile(customerFollowRecordsDto.getFileList(),customerFollowRecordsDto.getId());
    }

    @DSTransactional
    @Override
    public void delete(Long id) {
        this.removeById(id);
        ObsFileUtil.removeFile(id);
    }

}
