package com.fjhx.ehsd.controller.sample;

import org.springframework.web.bind.annotation.*;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.ehsd.entity.sample.vo.SampleVo;
import com.fjhx.ehsd.entity.sample.dto.SampleSelectDto;
import com.fjhx.ehsd.entity.sample.dto.SampleDto;
import com.ruoyi.common.core.domain.BaseSelectDto;
import com.fjhx.ehsd.service.sample.SampleService;
import org.springframework.beans.factory.annotation.Autowired;


/**
 * <p>
 * 样品单表 前端控制器
 * </p>
 *
 * @author 
 * @since 2023-05-05
 */
@RestController
@RequestMapping("/sample")
public class SampleController {

    @Autowired
    private SampleService sampleService;

    /**
     * 样品单表分页
     */
    @PostMapping("/page")
    public Page<SampleVo> page(@RequestBody SampleSelectDto dto) {
        return sampleService.getPage(dto);
    }

    /**
     * 样品单表明细
     */
    @PostMapping("/detail")
    public SampleVo detail(@RequestBody BaseSelectDto dto) {
        return sampleService.detail(dto.getId());
    }

    /**
     * 样品单表新增
     */
    @PostMapping("/add")
    public void add(@RequestBody SampleDto sampleDto) {
        sampleService.add(sampleDto);
    }

    /**
     * 样品单表编辑
     */
    @PostMapping("/edit")
    public void edit(@RequestBody SampleDto sampleDto) {
        sampleService.edit(sampleDto);
    }

    /**
     * 样品单表删除
     */
    @PostMapping("/delete")
    public void delete(@RequestBody BaseSelectDto dto) {
        sampleService.delete(dto.getId());
    }

}
